diff --git a/README.md b/README.md
index fcfc65abb4ff1df1f60f49efb3278e8644d748c3..d4fbef85d7f75d5557d5e16667d4aed36e9c2934 100644
--- a/README.md
+++ b/README.md
@@ -22,6 +22,7 @@ need to manually log on individual DUTs anymore.
 * FreeBSD 14
 * NetBSD 10
 * OpenBSD 7.5
+* Illumos: OpenIndiana Hipster
 
 ## Prerequisites
 
diff --git a/etc/hosts/illumos.cf b/etc/hosts/illumos.cf
new file mode 100644
index 0000000000000000000000000000000000000000..f22b24fcc0b099c9e1a55e296d089152c9d52e1c
--- /dev/null
+++ b/etc/hosts/illumos.cf
@@ -0,0 +1,7 @@
+HOST_OS_TYPE="illumos"
+HOST_JAIL_TYPE="illumos-chroot"
+HOST_CHROOT_RPOOL="rpool/chroot"
+HOST_CHROOT_DIR="/$HOST_CHROOT_RPOOL"
+HOST_PACKAGES="sudo rsync"
+
+[ "$TARGET_ID" ] || export TARGET_ID="$ILLUMOS_TARGET_ID"
diff --git a/etc/site.cf b/etc/site.cf
index 4b5d928b9959ae0d5f59dec3638b8136af6e991e..4539f327b1a5d4c774a8f399e7d7ef684e480bfc 100644
--- a/etc/site.cf
+++ b/etc/site.cf
@@ -1,6 +1,10 @@
 # not set - autodetect
 # HOST_OS="freebsd"
+
+# NOTE: etc/hosts/illumos.cf overwrite this, since there it needs
+# to be in the rpool
 HOST_CHROOT_DIR="/var/chroots/xorg-testing"
+
 GIT_CLONE_ARGS="--depth 1"
 XORG_PREFIX="/usr/local/X11"
 
@@ -15,3 +19,6 @@ NETBSD_TARGET_ID="netbsd-10"
 
 # target when running on OpenBSD host
 OPENBSD_TARGET_ID="openbsd-7.5"
+
+# target when running on illumos/openindiana host
+ILLUMOS_TARGET_ID="openindiana-hipster"
diff --git a/etc/targets/openindiana-hipster.cf b/etc/targets/openindiana-hipster.cf
new file mode 100644
index 0000000000000000000000000000000000000000..1dc1d6139d0c86eb4773137dcaa1443ef2c1dfa8
--- /dev/null
+++ b/etc/targets/openindiana-hipster.cf
@@ -0,0 +1,44 @@
+TARGET_OS="illumos"
+TARGET_WORKDIR="/srv/xorg-playground"
+TARGET_RELEASE="hipster"
+TARGET_ARCH="amd64"
+TARGET_PACKAGES="
+    meson gcc-13
+    developer/build/autoconf
+    developer/build/libtool
+    developer/build/automake
+    developer/build/gnu-make
+    developer/build/pkgconf
+    developer/build/pkg-config
+    developer/versioning/git
+    file/gnu-coreutils
+    library/python/pip-39
+    shell/bash
+    service/opengl/ogl-select
+    system/header/header-audio
+    system/header/header-drm
+    system/header/header-usb
+    text/gawk
+    x11/keyboard/xkbcomp
+    x11/library/libepoxy
+    x11/library/libxfont2
+    x11/library/libxshmfence
+    x11/library/mesa
+    x11/library/xtrans
+    x11/mkfontdir
+    x11/mkfontscale
+"
+
+#PACKAGE_XSERVER_EXTRA_CFLAGS="-I/usr/include/wurst/../"
+PACKAGE_LIBDRM_BUILD_ARGS="-Dnouveau=disabled"
+
+[ "${OPENINDIANA_HIPSTER_DRIVERS}" ] || OPENINDIANA_HIPSTER_DRIVERS="xf86-input-keyboard
+                                                                     xf86-input-mouse
+                                                                     xf86-video-vesa
+                                                                     xf86-video-intel"
+
+XORG_DRIVERS="${XORG_DRIVERS} ${OPENINDIANA_HIPSTER_DRIVERS}"
+XORG_EXTRA_DEPS="libxcvt"
+
+# need extra tools
+export PATH="$PATH:/usr/gnu/bin"
diff --git a/lib/base.sh b/lib/base.sh
index 57156d06dcfa3ab2faf62ccc55394cc53f39fbb0..cd5c20e3494e534cf1d52708dea6687b57dbc095 100644
--- a/lib/base.sh
+++ b/lib/base.sh
@@ -40,6 +40,10 @@ if [ ! "$HOST_OS" ]; then
             log "detected OpenBSD"
             export HOST_OS="openbsd"
         ;;
+        SunOS)
+            log "detected SunOS"
+            export HOST_OS="illumos"
+        ;;
         *)
             die "unknown uname: $(uname)"
         ;;
diff --git a/lib/build-xserver.sh b/lib/build-xserver.sh
index 55e5fa7adc444b0477c6ff034b0c323d1c89d9f7..606a48b86e4c7216ec81304ff5ba64be0c47204c 100755
--- a/lib/build-xserver.sh
+++ b/lib/build-xserver.sh
@@ -25,6 +25,14 @@ log "C-Compiler: $CC"
 TARGET_CC_ARCH=$($CC -dumpmachine)
 ARCH_LIBDIR="lib/$TARGET_CC_ARCH/"
 
+# fixme: speciality for Illumos
+if [ "$(uname)" == "SunOS" ]; then
+    mkdir -p /var/run/opengl/include/ /usr/include/GL/internal
+    ln -sf ../../../../usr/include/mesa/gl.h var/run/opengl/include/gl.h
+    ln -sf ../../../../usr/include/mesa/glext.h var/run/opengl/include/glext.h
+    ln -sf ../../mesa/internal/dri_interface.h /usr/include/GL/internal/dri_interface.h
+fi
+
 # fixme: this could be os/distro specific
 export PKG_CONFIG_PATH="$XORG_PREFIX/share/pkgconfig:$XORG_PREFIX/lib/pkgconfig:$XORG_PREFIX/$ARCH_LIBDIR/pkgconfig:$XORG_PREFIX/libdata/pkgconfig:/usr/local/libdata"
 
@@ -37,6 +45,11 @@ for i in $XORG_EXTRA_DEPS ; do
     build_package $i
 done
 
+# special hack for Illumos
+if [ "$(uname)" == "SunOS" ]; then
+    pip install strenum
+fi
+
 build_package xserver
 build_package xkeyboard-config
 build_package xkbcomp
diff --git a/lib/jail/jailrun-illumos-chroot b/lib/jail/jailrun-illumos-chroot
new file mode 100755
index 0000000000000000000000000000000000000000..d084733080c1485e38910a75a1fd657cf0503219
--- /dev/null
+++ b/lib/jail/jailrun-illumos-chroot
@@ -0,0 +1,49 @@
+#!/usr/bin/env bash
+
+# jail helper for schroot
+# it's needed as external script, in order to bridge sudo
+# Note: assuming we can be called ourselves in jail at the same path
+
+set -e
+SCRIPT_ROOT_DIR="$(cd "$(dirname "$0")/../../" && pwd -P)"
+
+. $SCRIPT_ROOT_DIR/lib/base.sh
+
+needvar TARGET_ID HOST_JAIL_TYPE
+
+command="$1"
+shift || true
+
+chroot_dir="$(get_builder_chroot_dir)"
+
+[ `uname` == "SunOS" ] || die "can only run on SunOS (Illumos)"
+
+case "$command" in
+    exec)
+        TARGET_ID="$TARGET_ID" sudo chroot "$chroot_dir" "$@" || die "failed jail command: $@"
+    ;;
+    install)
+        sudo chroot "$chroot_dir" "$SCRIPT_ROOT_DIR/lib/os/$TARGET_OS/target-package-install" "$@"
+    ;;
+    register)
+        mkdir -p "$chroot_dir/dev" "$chroot_dir/devices" "$chroot_dir/proc"
+        # FIXME: need error handling
+        mount -F lofs /dev "$chroot_dir/dev" || true
+        mount -F lofs /devices "$chroot_dir/devices" || true
+        mount -F lofs /proc "$chroot_dir/proc" || true
+        cp /etc/resolv.conf   "$chroot_dir/etc"
+        cp /etc/nsswitch.conf "$chroot_dir/etc"
+    ;;
+    syncme)
+        sudo rsync --no-acls -r "$SCRIPT_ROOT_DIR/" "$chroot_dir/$SCRIPT_ROOT_DIR"
+    ;;
+    stop)
+        # FIXME: need error handling
+        umount "$chroot_dir/dev" || true
+        umount "$chroot_dir/devices" || true
+        umount "$chroot_dir/proc" || true
+    ;;
+    *)
+        die "unknown command: $command -- $0 -- $@"
+    ;;
+esac
diff --git a/lib/os/illumos/files/srn.h b/lib/os/illumos/files/srn.h
new file mode 100644
index 0000000000000000000000000000000000000000..ef42bd522747133a8913057a24190df3c4941f5a
--- /dev/null
+++ b/lib/os/illumos/files/srn.h
@@ -0,0 +1,77 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#ifndef	_SYS_SRN_H
+#define	_SYS_SRN_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+/*
+ *	The following ioctl commands and structures may not exist
+ *	or may have a different interpretation in a future release.
+ */
+
+
+#define	SRN_STANDBY_REQ		0xa01
+#define	SRN_SUSPEND_REQ		0xa02
+#define	SRN_NORMAL_RESUME	0xa03
+#define	SRN_CRIT_RESUME		0xa04
+#define	SRN_BATTERY_LOW		0xa05
+#define	SRN_POWER_CHANGE	0xa06
+#define	SRN_UPDATE_TIME		0xa07
+#define	SRN_CRIT_SUSPEND_REQ	0xa08
+#define	SRN_USER_STANDBY_REQ	0xa09
+#define	SRN_USER_SUSPEND_REQ	0xa0a
+#define	SRN_SYS_STANDBY_RESUME	0xa0b
+#define	SRN_IOC_NEXTEVENT	0xa0c
+#define	SRN_IOC_RESUME		0xa0d
+#define	SRN_IOC_SUSPEND		0xa0e
+#define	SRN_IOC_STANDBY		0xa0f
+#define	SRN_IOC_AUTOSX		0xa10	/* change behavior of driver */
+
+typedef struct srn_event_info
+{
+	int	ae_type;
+
+} srn_event_info_t;
+
+#ifdef	_KERNEL
+
+#define	SRN_MAX_CLONE		8	/* only two consumer known */
+
+#define	SRN_TYPE_APM		1
+#define	SRN_TYPE_AUTOSX		2
+
+#endif
+
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _SYS_SRN_H */
diff --git a/lib/os/illumos/hostfunc.sh b/lib/os/illumos/hostfunc.sh
new file mode 100644
index 0000000000000000000000000000000000000000..b5804da1485af8bc5ef43b45f4fdbe0ead089e86
--- /dev/null
+++ b/lib/os/illumos/hostfunc.sh
@@ -0,0 +1,27 @@
+# this file is only included on $HOST_OS_TYPE="illumos"
+host_os_setup() {
+    local retval
+    if [ "$HOST_PACKAGES" ]; then
+        pkg install --no-refresh $HOST_PACKAGES || retval="$?"
+        if [ "$retval" != "" ] && [ "$retval" != 0 ] && [ "$retval" != 4 ]; then
+            die "package installation failed: retval=$retval"
+        fi
+    fi
+    log "host OS setup done"
+}
+
+host_fetch_tarball() {
+    local url="$1"
+    local fn="$2"
+
+    mkdir -p "$(dirname "$fn")"
+
+    if [ ! -f "$fn" ]; then
+        echo "fetching tarball: $url"
+        rm -f "$fn.TMP"
+        curl "$url" -o "$fn.TMP"
+        mv "$fn.TMP" "$fn"
+    else
+        echo "tarball already present: $fn"
+    fi
+}
diff --git a/lib/os/illumos/target-package-install b/lib/os/illumos/target-package-install
new file mode 100755
index 0000000000000000000000000000000000000000..6a0e2896f8a7ecd9db15af0a60196b8ee337e22e
--- /dev/null
+++ b/lib/os/illumos/target-package-install
@@ -0,0 +1,18 @@
+#!/bin/sh
+#
+# call be inside chroot to install target packages
+#
+
+set -e
+
+echo "(illumos) installing packages: $@"
+
+if [ "$1" != "" ]; then
+    pkg install --no-refresh "$@"|| retval="$?"
+    if [ "$retval" != "" ] && [ "$retval" != 0 ] && [ "$retval" != 4 ]; then
+        echo "package installation failed: retval=$retval" >&2
+        exit 1
+    fi
+fi
+
+echo "(illumos) package intallation finished"
diff --git a/lib/os/illumos/targetfunc.sh b/lib/os/illumos/targetfunc.sh
new file mode 100644
index 0000000000000000000000000000000000000000..175220f968ab306f94d2bab7c438e3b3b3456086
--- /dev/null
+++ b/lib/os/illumos/targetfunc.sh
@@ -0,0 +1,33 @@
+target_bootstrap_chroot() {
+    log "bootstrapping Illumos target from host"
+
+    needvar HOST_CHROOT_RPOOL
+
+    [ "$HOST_OS_TYPE" == "$TARGET_OS" ] || die "host $HOST_OS_TYPE mismatch target $TARGET_OS"
+
+    local chroot_dir="$(get_builder_chroot_dir)"
+    local chroot_name="$(get_builder_chroot_name)"
+    local chroot_rpool="$HOST_CHROOT_RPOOL/$chroot_name"
+
+    mkdir -p $(dirname "$chroot_dir")
+    log "zfs create $chroot_rpool"
+    zfs create $chroot_rpool || true
+
+    # FIXME: should support bootstrapping other releases, too
+    log "initialize chroot"
+    mkdir -p "$chroot_dir/var/pkg" \
+             "$chroot_dir/tmp" \
+             "$chroot_dir/etc" \
+             "$chroot_dir/dev" \
+             "$chroot_dir/devices" \
+             "$chroot_dir/proc"
+    cp /var/pkg/pkg5.image "$chroot_dir/var/pkg"
+
+    log "installing initial packages"
+    pkg -R "$chroot_dir" install pkg bash
+
+    if [ ! -f "$chroot_dir/usr/include/sys/srn.h" ]; then
+        log "need to copy sys/srn.h"
+        cp $SCRIPT_ROOT_DIR/lib/os/illumos/files/srn.h "$chroot_dir/usr/include/sys/srn.h"
+    fi
+}